

#include "ChangeListMenu.h"
#include <qbuttongroup.h>
#include <qradiobutton.h>

#define ADD_BUTTON_TO_GROUP( B, G, POPUP )\
  G->insert(B);\
  POPUP->insertItem(B);

ChangeListMenu::ChangeListMenu( QWidget* parent, const char* name ) :
  QPopupMenu( parent, name )
{
  insertItem( "New...", this, SLOT(slotNew()) );
  insertItem( "Edit Spec...", this, SLOT(slotEditSpec()) );
  insertItem( "Describe...", this, SLOT(slotDescribe()) );
  insertItem( "Describe Changelist...", this, SLOT(slotDescribeChangeList()) );
  insertItem( "Delete", this, SLOT(slotDelete()) );
  insertItem( "Submit...", this, SLOT(slotSubmit()) );

  insertSeparator();

  insertItem( "Add Job Fix...", this, SLOT(slotAddJobFix()) );
  insertItem( "Describe Job Fix...", this, SLOT(slotDescribeJobFix()) );
  insertItem( "Remove Job Fix", this, SLOT(slotRemoveJobFix()) );
  insertItem( "Revert Unchanged Files", this, SLOT(slotRevertUnchangedFiles()) );
  insertItem( "Sync to Changelist...", this, SLOT(slotSyncToChangeList()) );

  // TODO: make sub-men
  insertItem( "Integrate", this, SLOT(slotIntegrate()) );

  insertSeparator();

  insertItem( "Sort Files in Pending Changelists by Extension", this, 
    SLOT(slotSortFilesInPendingChangelistsByExtension()) );
  insertItem( "Sort Changes by User", this, SLOT(slotSortChangesByUser()) );

  insertSeparator();

  //======================================================================
  // filter radio buttons
  //
  
  _buttonGroup = new QButtonGroup();

  _unfilteredSubmittedChangelists = new QRadioButton(
    "Unfiltered Submitted Changelists", _buttonGroup );
  ADD_BUTTON_TO_GROUP( _unfilteredSubmittedChangelists, _buttonGroup, this );

  _fscForSelectedFiles = new QRadioButton(
    "Filtered Submitted Changelists for Selected Files", _buttonGroup );
  ADD_BUTTON_TO_GROUP( _fscForSelectedFiles, _buttonGroup, this );
  

  _fscForSelectedFilesIncludingIntegrations = new QRadioButton(
    "Filtered Submitted Changelists for Selected Files, including Integrations",
    _buttonGroup );
  ADD_BUTTON_TO_GROUP( _fscForSelectedFilesIncludingIntegrations, 
    _buttonGroup, this );  

  _fscByClient = new QRadioButton( "Filtered Submitted Changelists by Client...",
    _buttonGroup );
  ADD_BUTTON_TO_GROUP( _fscByClient, _buttonGroup, this );
  

  _fscByUser = new QRadioButton( "Filtered Submitted Changelists by User...",
    _buttonGroup );
  ADD_BUTTON_TO_GROUP( _fscByUser, _buttonGroup, this );    
  
  //======================================================================

  insertSeparator();

  insertItem( "View Pending Changelists", this, 
    SLOT(slotViewPendingChangelists()) );
  insertItem( "View Submitted Changelists", this,
    SLOT(slotViewPendingChangelists()) );
}

ChangeListMenu::~ChangeListMenu()
{

}
